Index: DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin.java	(revision 1415)
@@ -7,9 +7,10 @@
 import java.util.Comparator;
 import java.util.HashMap;
+import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
+import java.util.Set;
 
 import schedframe.events.scheduling.SchedulingEvent;
-import schedframe.exceptions.ResourceException;
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.StandardResourceType;
@@ -17,8 +18,11 @@
 import schedframe.resources.computing.Node;
 import schedframe.resources.computing.Processor;
-import schedframe.resources.computing.profiles.energy.airthroughput.StandardAirflowStateName;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowState;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowStateName;
+import schedframe.resources.computing.profiles.energy.airthroughput.CustomAirflowStateName;
 import schedframe.resources.computing.profiles.energy.power.PState;
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
 import schedframe.resources.devices.Device;
+import schedframe.resources.devices.Fan;
 import schedframe.resources.units.ProcessingElements;
 import schedframe.resources.units.ResourceUnit;
@@ -55,5 +59,5 @@
 			// check all tasks in queue
 
-			List<Node> notSelectedNodes = resourceManager.getNodes();
+			Set<Node> selectedNodes = new HashSet<Node>();
 			
 			for (int i = 0; i < q.size(); i++) {
@@ -67,9 +71,20 @@
 						ProcessingElements pe = (ProcessingElements) choosenResources.get(StandardResourceUnitName.PE);
 						Node node = (Node) pe.get(0).getParent();
-						notSelectedNodes.remove(node);
+						selectedNodes.add(node);
 					} 
 				}
 			}
-			turnOffIdleNodes(notSelectedNodes);
+			List<Node> nodes = resourceManager.getNodes();
+			nodes.removeAll(selectedNodes);
+			turnOffIdleNodes(nodes);
+			for(Node node: resourceManager.getNodes()){
+				for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
+					if(device.getType().equals(StandardResourceType.Fan)){
+						Fan fan = (Fan) device;
+						adjustFanSpeed(fan, selectedNodes);
+						break;
+					}
+				}
+			}
 			break;
 		}
@@ -84,10 +99,7 @@
 		Node node;
 		if(availableNodes.size() == 0){
-			try {
-				nodes = (List<Node>) resourceManager.getResourcesByTypeWithStatus(StandardResourceType.Node, ResourceStatus.UNAVAILABLE);
-			} catch (ResourceException e) {
-				// TODO Auto-generated catch block
-				e.printStackTrace();
-			}
+
+			nodes = (List<Node>) resourceManager.getResourcesByTypeWithStatus(StandardResourceType.Node, ResourceStatus.UNAVAILABLE);
+
 			Collections.sort(nodes, new PerformanceComparator());
 			node = turnOnFirstNode(nodes, task);
@@ -112,4 +124,5 @@
 			}
 		}
+
 		ProcessingElements result = new ProcessingElements(node.getFullName());
 		result.addAll(choosenResources);
@@ -167,10 +180,4 @@
 					continue;
 				else {
-					for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
-						if(device.getType().equals(StandardResourceType.Fan)){
-							device.getAirflowInterface().setAirflowState(StandardAirflowStateName.ON);
-							break;
-						}
-					}
 					node.getPowerInterface().setPowerState(StandardPowerStateName.ON);
 					startedNode = node;
@@ -190,13 +197,6 @@
 			
 			if(freeProcessors == node.getProcessors().size()) {
-				for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
-					if(device.getType().equals(StandardResourceType.Fan)){
-						device.getAirflowInterface().setAirflowState(StandardAirflowStateName.OFF);
-						break;
-					}
-				}
 				node.getPowerInterface().setPowerState(StandardPowerStateName.OFF);
 			}
-
 		}
 	}
@@ -249,4 +249,59 @@
 	    }
 	}
+	
+	private void adjustFanSpeed(Fan fan, Set<Node> selectedNodes){
+		AirflowStateName newState;
+		double totalLoad = 0;
+		double loadLevel;
+		ComputingResource compRes = fan.getComputingResource();
+		for(ComputingResource n: compRes.getChildren()){
+			if(fan.getChilledResources().contains(n.getFullName())){
+				if(selectedNodes.contains(n)){
+					totalLoad = totalLoad + 100;
+				} else {
+					totalLoad = totalLoad + n.getLoadInterface().getRecentUtilization().getValue();
+				}	
+			}
+		}
+		loadLevel = totalLoad / compRes.getChildren().size();
+		
+		double highestLoadLevel = 0;
+
+		if(fan.getAirflowInterface().supportAirflowState(new CustomAirflowStateName("ON_" + new Double(loadLevel).intValue()))){
+			newState = new CustomAirflowStateName("ON_" + new Double(loadLevel).intValue());
+		} else {
+			for(AirflowState airflowState: fan.getAirflowInterface().getSupportedAirflowStates()){
+				Double load;
+				try{
+					load = Double.valueOf(airflowState.getName().getLabel().substring(3));
+				}catch (Exception e){
+					continue;
+				}
+				if(highestLoadLevel < load){
+					highestLoadLevel = load;
+				}
+			}
+			if(loadLevel == 0){
+				newState = new CustomAirflowStateName("OFF");
+			} else {
+
+				double higherLoadLevel = highestLoadLevel;
+
+				for(AirflowState airflowState: fan.getAirflowInterface().getSupportedAirflowStates()){
+					Double load;
+					try{
+						load = Double.valueOf(airflowState.getName().getLabel().substring(3));
+					}catch (Exception e){
+						continue;
+					}
+					if(loadLevel < load){
+						higherLoadLevel = load;
+					}
+				}
+				newState = new CustomAirflowStateName("ON_" + Double.valueOf(higherLoadLevel).intValue());
+			}
+		}
+		fan.getAirflowInterface().setAirflowState(newState);
+	}
 
 }
Index: DCWoRMS/branches/coolemall/src/example/timeestimation/coolemall/PhaseBasedTimeEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/timeestimation/coolemall/PhaseBasedTimeEstimationPlugin.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/example/timeestimation/coolemall/PhaseBasedTimeEstimationPlugin.java	(revision 1415)
@@ -0,0 +1,77 @@
+package example.timeestimation.coolemall;
+
+
+import java.util.Map;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Core;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.units.PEUnit;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import dcworms.schedframe.scheduling.ExecTask;
+import example.timeestimation.BaseTimeEstimationPlugin;
+
+public class PhaseBasedTimeEstimationPlugin extends BaseTimeEstimationPlugin{
+
+	/*
+	 * This method should return an estimation of time required to execute the task.
+	 * Requested calculation should be done based on the resources allocated for the task,
+	 * task description and task completion percentage.
+	 * 
+	 * Example implementation calculate the estimation based on processing power.
+	 * There is also a simple assumption, that processing power is a linear function
+	 * of number of allocated units and their speed.
+	 */
+	public double execTimeEstimation(SchedulingEvent event, ExecTask task,
+			Map<ResourceUnitName, ResourceUnit> allocatedResources,
+			double completionPercentage) {
+		
+
+		//String taskFreqString = task.getExecutionProfile().getCurrentResourceConsumption().getReferenceHardware().get("cpu_maxfreq");
+		//double taskFreq = Double.valueOf(taskFreqString);
+
+		double speed = 0;
+		PEUnit peUnit = (PEUnit) allocatedResources.get(StandardResourceUnitName.PE);	
+		
+		try {
+			ProcessingElements pes = (ProcessingElements) peUnit;
+			for (ComputingResource compResource : pes) {
+				if(compResource instanceof Core) {
+					Core core = (Core) compResource;
+					speed = core.getProcessor().getPowerInterface().getPState().getFrequency();
+					break;
+				} else if (compResource instanceof Processor) {
+					Processor processor = (Processor) compResource;
+					speed = processor.getPowerInterface().getPState().getFrequency();
+					break;
+				}
+			}		
+		} catch (Exception e){
+			speed = peUnit.getSpeed();			
+		}
+
+		//speed =  taskFreq;
+		int cnt = peUnit.getUsedAmount();
+
+		double execTime = (1 - completionPercentage/100) * task.getExecutionProfile().getCurrentResourceConsumption().getLenght() / (speed * cnt);
+
+		//double execTime = (1 - completionPercentage/100) * task.getExecutionProfile().getCurrentResourceConsumption().getDuration() * (taskFreq / currentFrequency);
+		//double execTime = (1 - completionPercentage/100) * task.getExecutionProfile().getCurrentResourceConsumption().getDuration();
+		
+		// if the result is very close to 0, but less then one millisecond then round this result to 0.001
+		if (Double.compare(execTime, 0.001) < 0) {
+			execTime = 0.001;
+		}
+
+		// time is measured in integer units, so get the nearest execTime int value.
+		execTime = Math.round(execTime);
+		return execTime;
+	}
+
+}
+
+
Index: DCWoRMS/branches/coolemall/src/example/load/ProcessorLoadEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/load/ProcessorLoadEstimationPlugin.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/example/load/ProcessorLoadEstimationPlugin.java	(revision 1415)
@@ -2,14 +2,14 @@
 
 import schedframe.resources.computing.Processor;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
-import schedframe.scheduling.tasks.phases.PhaseBehaviour;
+import schedframe.scheduling.tasks.phases.PhaseSystemLoad;
 import dcworms.schedframe.scheduling.ExecTask;
 
 public class ProcessorLoadEstimationPlugin extends BaseLoadEstimationPlugin{
 
-	public double estimateUtlization(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
+	public double estimateUtlization(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
 		Processor proc = (Processor) resource;
 		double sumCoresLoad = 0;
@@ -26,5 +26,5 @@
 			double cpuUsage = 1 / nrOfThreadsOnCpu;
 
-			for(PhaseBehaviour pb: task.getExecutionProfile().getCurrentResourceConsumption().getBehaviourList()){
+			for(PhaseSystemLoad pb: task.getExecutionProfile().getCurrentResourceConsumption().getSystemLoad()){
 				if(pb.getResouceName().equals("PM_CPU_Usage")){
 					cpuUsage = pb.getUtilization();
Index: DCWoRMS/branches/coolemall/src/example/load/DefaultLoadEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/load/DefaultLoadEstimationPlugin.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/example/load/DefaultLoadEstimationPlugin.java	(revision 1415)
@@ -2,5 +2,5 @@
 
 import schedframe.resources.computing.ComputingResource;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -10,5 +10,5 @@
 public class DefaultLoadEstimationPlugin extends BaseLoadEstimationPlugin{
 
-	public double estimateUtlization(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
+	public double estimateUtlization(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
 
 		ComputingResource computingResource = (ComputingResource) resource;
Index: DCWoRMS/branches/coolemall/src/dcworms/schedframe/scheduling/Executable.java
===================================================================
--- DCWoRMS/branches/coolemall/src/dcworms/schedframe/scheduling/Executable.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/dcworms/schedframe/scheduling/Executable.java	(revision 1415)
@@ -30,5 +30,5 @@
 import schedframe.scheduling.tasks.AbstractProcessesGroup;
 import schedframe.scheduling.tasks.Task;
-import schedframe.scheduling.tasks.phases.ResourceConsumption;
+import schedframe.scheduling.tasks.phases.ExecutionPhase;
 import schedframe.scheduling.tasks.phases.ExecutionProfile;
 import schedframe.scheduling.tasks.requirements.ResourceParameterName;
@@ -48,5 +48,5 @@
 	
 	protected String reservationId;
-	protected double completionPercentage;
+	protected double completionPercentageTotal;
 	
 	protected int estimatedDuration;
@@ -64,5 +64,5 @@
 	protected ExecutionProfile execProfile;
 	
-	protected LinkedList<ExecutionHistoryItem> execHistory;;
+	protected LinkedList<ExecutionHistoryItem> execHistory;
 	protected LinkedList<ResourceItem> allocatedResources;
 	
@@ -187,5 +187,5 @@
 		
 		if (newStatus == DCWormsTags.SUCCESS || newStatus == DCWormsTags.CANCELED) {
-            finishTime = DateTimeUtilsExt.currentTimeMillis() / 1000;
+            finishTime = currentTime;
         }
 		
@@ -196,6 +196,6 @@
         if ((prevStatus == DCWormsTags.INEXEC) && (status == DCWormsTags.CANCELED || status == DCWormsTags.PAUSED ||
                 status == DCWormsTags.SUCCESS)){
-                totalCompletionTime += (currentTime -  execStartTime);
-                execStartTime = execStartTimeFirst;
+            totalCompletionTime += (currentTime -  execStartTime);
+            execStartTime = execStartTimeFirst;
         }
 
@@ -218,5 +218,5 @@
         if(status == DCWormsTags.NEW_EXEC_PHASE && prevStatus == DCWormsTags.INEXEC){
     		status = DCWormsTags.INEXEC;
-    		completionPercentage = 0;
+    		execProfile.setCompletionPercentage(0.0);
     		execProfile.setCurrentPhase(execProfile.getCurrentPhase() + 1);
         }
@@ -255,10 +255,10 @@
 	}
 	
-	public double getCompletionPercentage() {
-		return completionPercentage;
-	}
-
-	public void setCompletionPercentage(double completionPercentage) {
-		this.completionPercentage = completionPercentage;
+	public double getTotalCompletionPercentage() {
+		return completionPercentageTotal;
+	}
+
+	public void setTotalCompletionPercentage(double completionPercentage) {
+		this.completionPercentageTotal = completionPercentage;
 	}
 
@@ -370,8 +370,4 @@
 	}
 
-	public ResourceConsumption getCurrentResourceConsumption(){
-		return execProfile.getCurrentResourceConsumption();
-	}
-	
 	public String getApplicationName(){
 		return task.getApplicationName();
@@ -379,5 +375,5 @@
 	
 	private void preparePhases(String resourceType) {
-		LinkedList<ResourceConsumption> resourceConsumptionList = new LinkedList<ResourceConsumption>();
+		LinkedList<ExecutionPhase> resourceConsumptionList = new LinkedList<ExecutionPhase>();
 		
 		long usefulWork = -1;
@@ -385,7 +381,7 @@
 		if(task.getDescription().getExecution() == null || task.getDescription().getExecution().getResourceConsumptionProfile() == null
 				|| task.getDescription().getExecution().getResourceConsumptionProfile().length == 0 ){
-			ResourceConsumption resConsumption = null;
+			ExecutionPhase resConsumption = null;
 			try {
-				resConsumption = new ResourceConsumption(getLength(), task.getComputingResourceRequirements());
+				resConsumption = new ExecutionPhase(getLength(), task.getComputingResourceRequirements());
 			} catch (NoSuchFieldException e) {
 				// TODO Auto-generated catch block
@@ -399,5 +395,5 @@
 					if(resConsumptioProfile.getType() != null && resConsumptioProfile.getType().equals(resourceType)){
 						for(ResourceConsumptionType resConsumption: resConsumptioProfile.getResourceConsumption()){
-							ResourceConsumption resourceConsumption = new ResourceConsumption(resConsumption);
+							ExecutionPhase resourceConsumption = new ExecutionPhase(resConsumption);
 							resourceConsumptionList.add(resourceConsumption);
 						}
@@ -415,5 +411,5 @@
 			if(!found){
 				for(ResourceConsumptionType resConsumption: task.getDescription().getExecution().getResourceConsumptionProfile()[0].getResourceConsumption()){
-					ResourceConsumption resourceConsumption = new ResourceConsumption(resConsumption);
+					ExecutionPhase resourceConsumption = new ExecutionPhase(resConsumption);
 					resourceConsumptionList.add(resourceConsumption);
 				}
Index: DCWoRMS/branches/coolemall/src/gridsim/dcworms/DCWormsTags.java
===================================================================
--- DCWoRMS/branches/coolemall/src/gridsim/dcworms/DCWormsTags.java	(revision 1381)
+++ DCWoRMS/branches/coolemall/src/gridsim/dcworms/DCWormsTags.java	(revision 1415)
@@ -10,5 +10,5 @@
 	protected static final int DCWORMSBASE = 600; 
 	
-	public static final int TO_COMP_RESOURCES = DCWORMSBASE - 4;
+	public static final int TO_RESOURCES = DCWORMSBASE - 4;
 	
 	public static final int TO_SCHEDULERS = DCWORMSBASE - 3;
Index: DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java	(revision 1346)
+++ DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java	(revision 1415)
@@ -271,9 +271,7 @@
 
 
-		boolean traceFlag = true; // means: trace GridSim events/activities
-		String[] excludeFromFile = { "" }, excludeFromProcessing = { "" };
-		
-		GridSimWrapper.init(numUser, calendar, traceFlag, excludeFromFile,
-				excludeFromProcessing, null);
+		boolean traceFlag = false; // means: trace GridSim events/activities
+
+		GridSimWrapper.init(numUser, calendar, traceFlag);
 		DateTimeUtilsExt.initVirtualTimeAccess(calendar);
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/DCwormsMetricsCalculator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/DCwormsMetricsCalculator.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/DCwormsMetricsCalculator.java	(revision 1415)
@@ -14,8 +14,6 @@
 	public List<MetricsStats> calulateMetrics(){
 		List<MetricsStats> metrics = new ArrayList<MetricsStats>();
-		/*for(String resourceTypeName: metricsData.keySet()){
-			MetricsStats metric = new MetricsStats(resourceTypeName, "energyUsage", metricsData.get(resourceTypeName).getMax());
-			metrics.add(metric);}
-		}*/
+
+		/*
 		metrics.add(calculateITComputingEnergyConsumption());
 		metrics.add(calculateITEnergyConsumption());
@@ -34,5 +32,6 @@
 		metrics.add(calculateUsefulWork());
 		metrics.add(calculateProductivity());
-
+		 */
+		
 		return metrics;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/EventHandler.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/EventHandler.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/EventHandler.java	(revision 1415)
@@ -2,8 +2,9 @@
 
 import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 
 public interface EventHandler {
 	
-	public void handleResourceEvent(Event event);
+	public void handleResourceEvent(ResourceEvent event);
 	
 	public void handleSchedulingEvent(SchedulingEvent event);
Index: DCWoRMS/branches/coolemall/src/schedframe/events/EventCommand.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/EventCommand.java	(revision 1316)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/EventCommand.java	(revision 1415)
@@ -1,3 +1,5 @@
 package schedframe.events;
+
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 
 
@@ -5,4 +7,4 @@
 public interface EventCommand {
 	
-	public void execute(Event event);
+	public void execute(ResourceEvent event);
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/events/Event.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/Event.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/Event.java	(revision 1415)
@@ -1,5 +1,4 @@
 package schedframe.events;
 
-import schedframe.events.scheduling.EventReason;
 
 public interface Event {
@@ -9,6 +8,4 @@
 	public String getSource();
 	
-	public int getTag();
-	
 	public Object getData();
 	
Index: DCWoRMS/branches/coolemall/src/schedframe/events/EventType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/EventType.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/EventType.java	(revision 1415)
@@ -5,5 +5,3 @@
 	public String getName();
 	
-	public int getTag();
-	
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/ResourceStateChangedEvent.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/ResourceStateChangedEvent.java	(revision 1316)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/ResourceStateChangedEvent.java	(revision 1415)
@@ -1,22 +1,17 @@
 package schedframe.events.scheduling;
 
-import schedframe.events.EventType;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 
-public class ResourceStateChangedEvent  extends SchedulingEvent {
+public class ResourceStateChangedEvent extends SchedulingEvent {
 
-	protected String resourceName;
-	protected EventType eventType;
+	protected ResourceEventType eventType;
 	
-	public ResourceStateChangedEvent(String resourceName, EventType eventType) {
+	public ResourceStateChangedEvent(ResourceEventType eventType) {
 		super(SchedulingEventType.RESOURCE_STATE_CHANGED);
-		this.resourceName = resourceName;
 		this.eventType = eventType;
 	}
 
-	public String getResourceName() {
-		return resourceName;
-	}
 
-	public EventType getEventType() {
+	public ResourceEventType getResourceEventType() {
 		return eventType;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventCommand.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventCommand.java	(revision 1316)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventCommand.java	(revision 1415)
@@ -1,7 +1,7 @@
 package schedframe.events.scheduling;
 
-import schedframe.events.Event;
 import schedframe.events.EventCommand;
 import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 
 public class SchedulingEventCommand implements EventCommand {
@@ -13,6 +13,6 @@
 	}
 	
-	public void execute(Event event) {
-		SchedulingEvent ev = new ResourceStateChangedEvent(compResource.getFullName(), event.getType());
+	public void execute(ResourceEvent event) {
+		SchedulingEvent ev = new ResourceStateChangedEvent(event.getType());
 		ev.setSource(compResource.getFullName());
 		compResource.getEventHandler().handleSchedulingEvent(ev);
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskPausedEvent.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskPausedEvent.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskPausedEvent.java	(revision 1415)
@@ -0,0 +1,22 @@
+package schedframe.events.scheduling;
+
+public class TaskPausedEvent extends SchedulingEvent {
+
+	protected String jobId;
+	protected String taskId;
+	
+	public TaskPausedEvent(String jobId, String taskId) {
+		super(SchedulingEventType.TASK_PAUSED);
+		this.jobId = jobId;
+		this.taskId = taskId;
+	}
+
+	public String getJobId() {
+		return jobId;
+	}
+
+	public String getTaskId() {
+		return taskId;
+	}
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEvent.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEvent.java	(revision 1316)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEvent.java	(revision 1415)
@@ -2,4 +2,5 @@
 
 import schedframe.events.Event;
+import schedframe.events.EventReason;
 import schedframe.events.EventType;
 
@@ -25,5 +26,5 @@
 			schedEventType = (SchedulingEventType)type;
 		} catch(Exception e){
-			schedEventType = SchedulingEventType.RESOURCE_STATE_CHANGED;
+			schedEventType = null;
 		}
 		return schedEventType;
@@ -42,8 +43,4 @@
 	}
 
-	public int getTag() {
-		return type.getTag();
-	}
-
 	public Object getData() {
 		return null;
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventType.java	(revision 1360)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventType.java	(revision 1415)
@@ -6,48 +6,33 @@
 
 	// task related
-	TASK_FINISHED(1),
-	TASK_FAILED(2),
-	TASK_CANCELED(4),
-	TASK_ARRIVED(8),
-	TASK_PAUSED(16),
-	TASK_RESUMED(32),
-	TASK_MOVED(64),
-	START_TASK_EXECUTION(128),
-	TASK_REQUESTED_TIME_EXPIRED(256),
+	TASK_FINISHED,
+	TASK_FAILED,
+	TASK_CANCELED,
+	TASK_ARRIVED,
+	TASK_PAUSED,
+	TASK_RESUMED,
+	TASK_MOVED,
+	TASK_EXECUTION_CHANGED,
+	START_TASK_EXECUTION,
+	TASK_REQUESTED_TIME_EXPIRED,
 
 	//job related
-	JOB_ARRIVED(512),
-	JOB_FINISHED(1024),
-	JOB_FAILED(2048),
-	JOB_CANCELED(4096),
+	JOB_ARRIVED,
+	JOB_FINISHED,
+	JOB_FAILED,
+	JOB_CANCELED,
 
 	//time related
-	TIMER(8192),
+	TIMER,
+		
+	//resource related
+	RESOURCE_FAILED,
+	//provider related (relevant to grid scheduling)
+	PROVIDER_FAILED,
+
+	RESOURCE_STATE_CHANGED,
 	
-	//reservation related
-	RESERVATION_ACTIVE(16384),
-	RESERVATION_FINISHED(32768),
-	RESERVATION_FAILED(65536),
-	RESERVATION_EXPIRED(131072),
-	
-	//resource related
-	RESOURCE_FAILED(262144),
-	//provider related (relevant to grid scheduling)
-	PROVIDER_FAILED(524288),
+	POWER_LIMIT_EXCEEDED;
 
-	RESOURCE_STATE_CHANGED(1048576),
-	
-	POWER_LIMIT_EXCEEDED(2097152)
-	;
-	
-	protected int tag;
-	
-	private SchedulingEventType(int tag){
-		this.tag = tag;
-	}
-	
-	public int getTag(){
-		return this.tag;
-	}
 	
 	public String getName(){
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskResumedEvent.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskResumedEvent.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskResumedEvent.java	(revision 1415)
@@ -0,0 +1,22 @@
+package schedframe.events.scheduling;
+
+public class TaskResumedEvent extends SchedulingEvent {
+
+	protected String jobId;
+	protected String taskId;
+	
+	public TaskResumedEvent(String jobId, String taskId) {
+		super(SchedulingEventType.TASK_RESUMED);
+		this.jobId = jobId;
+		this.taskId = taskId;
+	}
+
+	public String getJobId() {
+		return jobId;
+	}
+
+	public String getTaskId() {
+		return taskId;
+	}
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskCanceledEvent.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskCanceledEvent.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/TaskCanceledEvent.java	(revision 1415)
@@ -2,4 +2,6 @@
 
 import java.util.List;
+
+import schedframe.events.EventReason;
 
 
Index: DCWoRMS/branches/coolemall/src/schedframe/events/ResourceEventCommand.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/ResourceEventCommand.java	(revision 1316)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/ResourceEventCommand.java	(revision 1415)
@@ -1,4 +1,5 @@
 package schedframe.events;
 
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 import schedframe.resources.devices.PhysicalResource;
 
@@ -11,5 +12,5 @@
 	}
 
-	public void execute(Event event) {
+	public void execute(ResourceEvent event) {
 		resource.getEventHandler().handleResourceEvent(event);
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/EventReason.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/EventReason.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/EventReason.java	(revision 1415)
@@ -0,0 +1,24 @@
+package schedframe.events;
+
+public enum EventReason {
+	
+	//Reasons that caused given events
+	UNKNOWN,
+
+	//task-related
+	//TASK_FAILED
+	APP_FAILURE,
+	SYSTEM_FAILURE,
+	RESOURCE_FAILURE,
+	
+	//TASK_CANCELED
+	RESOURCES_EXCEEDED,
+	
+	//resource/provider-related
+	TEMPORARY_FAILURE,
+	PERMAMENT_FAILURE,
+	
+	
+	SIM_INIT
+	;
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/tasks/JobRegistryImpl.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/tasks/JobRegistryImpl.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/tasks/JobRegistryImpl.java	(revision 1415)
@@ -55,10 +55,10 @@
 					Set<String> visitedResource = task.getAllocatedResources().getLast().getResourceNames();
 					for(String res: visitedResource){
-						if(res.contains(context)){
+						if(res.equals(context) || res.substring(0, res.lastIndexOf("/")).contains(context)){
 							taskList.add(task);
 							break;
 						}
 					}
-					if(task.getSchedulerName().contains(context)) {
+					if(task.getSchedulerName().equals(context)) {
 						taskList.add(task);
 					}
